#include "class_container.h"

nsattrib::nsattrib()
{
    reload = 50;
}

int nsattrib::init(vector < char * > &fpv_conffile, vector < char * > &fpv_classfile)
{
    unsigned int default_low = 0;
    unsigned int default_ceil = 0;
    unsigned int default_htb_prio = 5;
    unsigned int default_hold = 30;
    unsigned int default_prio = 0;
    unsigned int classid = 1000;
    unsigned int filterid = 0;
    unsigned int sfq_perturb = 0;    
    unsigned int esfq_perturb = 0;    
    char classtype[SHORT_BUF] = "standard-class";
    char scheduler[SHORT_BUF] = "sfq";
    char esfq_hash[SHORT_BUF] = "";
    char buf[LONG_BUF], buf2[LONG_BUF];
    char option[SHORT_BUF], param[SHORT_BUF], value[SHORT_BUF];
    char default_option[SHORT_BUF], default_param[SHORT_BUF], default_value[SHORT_BUF];
    char dev_[MAX_IFACE], dev__[MAX_IFACE];
    bool alias;
    bool imq_auto_redirect = false;
    bool ipt_return = false;
    char section_set[SHORT_BUF];
    char section_end[SHORT_BUF];
    vector < char * >::iterator fpvi, fpvi_begin, fpvi_end, fpvi_tmp; 
    vector < char * > fpv_myclasses;
    char *buf_ptr;  
    bool mydatablock ;
    int class_default_mark;
    bool is_protected;  
    bool default_param_should_be_inserted;

    sprintf( section_set, "<%s>", section );
    sprintf( section_end, "</%s>", section );

    fpv_section_i( fpvi_begin, fpvi_end, fpv_conffile, section );

/*    fpvi = fpvi_begin;  
    while ( fpvi != fpvi_end ) {
	printf("config:%s\n",*fpvi);
	fpvi++;
    }*/

    fpvi = fpvi_begin;  
    while ( fpvi != fpvi_end ) 
    {
	strcpy ( buf , *fpvi );
	fpvi++;
	strcpy ( option, awk( buf, 1 ));
	strcpy ( param, awk( buf, 2 ));
	strcpy ( value, awk( buf, 3 ));
	if ( !strcmp( option, "section" )) 
	{
	    if ( !strcmp( param, "speed" )) section_htb_ceil = unitconvert( value, bit );
	    else if ( !strcmp( param, "shape" )) section_shape = unitconvert( value, bit );
	    else { dump_error( 11, buf ); return -1; }
	} 
	else if ( !strcmp( option, "default" )) 
	{
	    strcpy ( default_option, awk( buf, 2 ));
	    strcpy ( default_param, awk( buf, 3 ));
	    strcpy ( default_value, awk( buf, 4 ));
 	    if      ( !strcmp( default_option, "low" )) default_low = unitconvert( default_param, bit); 
	    else if ( !strcmp( default_option, "ceil" )) default_ceil = unitconvert( default_param, bit); 
	    else if ( !strcmp( default_option, "rate" )) default_low = default_ceil = unitconvert(  default_param, bit); 
	    else if ( !strcmp( default_option, "hold" )) default_hold = atoi( default_param ); 
	    else if ( !strcmp( default_option, "prio" )) default_prio = atoi( default_param ); 
	    else if ( !strcmp( default_option, "htb-prio" )) { default_htb_prio = atoi( default_param ); dump_warning( 1, buf ); }
	    else if ( !strcmp( default_option, "htb-scheduler" )) { strcpy( scheduler, default_param ); dump_warning( 1, buf ); }
	    else if ( !strcmp( default_option, "iptables-return" )) { ipt_return = true; dump_warning( 1, buf ); }
	    else if ( !strcmp( default_option, "imq-redirect" )) imq_auto_redirect = true;		
    	    else if ( !strcmp( default_option, "do-not-shape" )) strcpy(classtype, "do-not-shape");
    	    else if ( !strcmp( default_option, "virtual" )) strcpy(classtype, "virtual");
    	    else if ( !strcmp( default_option, "wrapper" )) strcpy(classtype, "wrapper");
	    else if ( !strcmp( default_option, "htb" )) 
	    {
	        if ( !strcmp( default_param, "prio" )) default_htb_prio = atoi( default_value ); 
		else if ( !strcmp( default_param, "scheduler" )) strcpy( scheduler, default_value ); 
	        else { dump_error( 11, buf ); return -1; }

	    }    
	    else if ( !strcmp( default_option, "sfq" )) {
	        if ( !strcmp( default_param, "perturb" )) sfq_perturb = atoi( default_value );
	        else { dump_error( 11, buf ); return -1; }  
	    }
	    else if ( !strcmp( default_option, "esfq" )) {                                                                                                                   
	        if ( !strcmp( default_param, "perturb" )) {                                                                                                                
	    	    esfq_perturb = atoi( default_value );                                                                                                                    
		}                                                                                                                                                    
		else if ( !strcmp( default_param, "hash" )) {                                                                                                                
		    if ( !strcmp( default_value, "classic" )) strcpy( esfq_hash, "classic" );                                                                                
		    else if ( !strcmp( default_value, "dst" )) strcpy( esfq_hash, "dst" );                                                                                   
		    else if ( !strcmp( default_value, "src" )) strcpy( esfq_hash, "src" );                                                                                   
		    else { dump_error( 11, buf ); return -1; }                                                                                                       
		}                                                                                                                                                    
		else { dump_error( 11, buf ); return -1; }                                                                                                           
	    }            
	    else if ( !strcmp( default_option, "iptables" )) 
	    { 
	        if ( !strcmp( default_param, "return" )) {                                                                                                                	    
		    if ( !strcmp( default_value, "true" )) ipt_return=true;
		    else if ( !strcmp( default_value, "false" )) ipt_return=false;
		    else { 
			dump_error( 11, buf ); 
			return -1; 
		    }	
		} 
		else { 
		    dump_error( 11, buf ); 
		    return -1; 
		}                                                                                                       
	    }	
	}
	else if ( !strcmp( option, "reload" )) 
	{  
	    if ( !strcmp( param, "false" )) {
    		reload = 0;
	    }
	    else {
    		reload = (unsigned int)(strtof(param, NULL)*10);
    	        if (( reload == 0 ) || ( reload > 6000 )) {
		    dump_error( 13, buf );
    		    return -1;
		}
	    }
	}
	else if ( !strcmp( option, "iptables" )) 
	{
	    if (( !strcmp( param, "append-hook" )) || (!strcmp( param, "hook" ))) strcpy ( ipt_myparent_mode , " -A " );		
	    else if ( !strcmp( param, "insert-hook" )) strcpy ( ipt_myparent_mode , " -I " );
	    else { dump_error( 11, buf ); return -1; }
	    
	    if ( strcmp ( value ,"PREROUTING" ) && strcmp ( value ,"POSTROUTING" ) && 
	    strcmp ( value ,"INPUT" ) && strcmp ( value ,"OUTPUT" ) && strcmp ( value ,"FORWARD" ) ) {
	        dump_warning( 2, buf );
	    }
	    else {
	        strcpy( ipt_myparent, value );
	    }
	}
	else if ( !strcmp( option, "mode" ))
	{
	    if ( !strcmp( param, "download" )) strcpy( ipt_myparent, "POSTROUTING" );
	    else if ( !strcmp( param, "upload" )) strcpy(ipt_myparent, "PREROUTING");
	    else { dump_error( 14, buf ); return -1; }
	    strcpy ( ipt_myparent_mode , " -A " );
	}
	else if ( !strcmp( option, "debug" )) 
	{
	    if ( !strcmp( param, "iptables" )) debug_ipt = true;
	    else if ( !strcmp( param, "iproute")) debug_tc = true;
	} 
	else if (!strcmp(option, "iface")) 
	{
	    fpvi_tmp = fpvi;
	    strcpy(dev_, awk(*fpvi, 2));
	    fpvi = fpvi_begin;
	    alias = false;
	    while ( fpvi != fpvi_tmp ) 
	    { 	  
		strcpy ( buf , *fpvi );		
		fpvi++;
		strcpy ( option, awk(buf, 1));
		if (!strcmp(option, "iface") && (fpvi != fpvi_tmp)) {
		  strcpy(dev__, awk(buf, 2));
	  	  if (!strcmp(dev_, dev__)) alias = true;
		}
	    }
	    fpvi = fpvi_tmp;
	    strcpy(buf2, buf);
	    net.push_back( new netattrib());
//	    if (net[net.size() - 1]->init(buf2, alias) == -1) return -1;
	    if ( net.back()->init( buf2, alias ) == -1 ) return -1;
	    alias = false;
	} 
	else if (!strcmp(option, "<global>") || !strcmp(option, "</global>")) 
	    continue;
	else if (!strcmp(option, section_set) || !strcmp(option, section_end)) 
	    continue;
	else {
	    dump_error ( 11, buf );	
	    return -1;
	}
    }
    
    if ( !section_htb_ceil ) dump_error(19, ""); 
    if ( !section_shape ) dump_error(20, ""); 
    if ( !strlen ( ipt_myparent ) ) dump_error(21, ""); ;
    if ( !net.size() ) dump_error(22, ""); ;
    if ( !default_ceil ) default_ceil = section_shape; 
    
    if ( fatal_error ) return -1;

    //fpvi = fpv_classfile.begin();
    //while ( fpvi != fpv_classfile.end() ) { 
//	printf("class:%s\n",*fpvi);
//	fpvi++;
//    }
    
    mydatablock = false;
    fpvi=fpv_classfile.begin();
    while ( fpvi != fpv_classfile.end() ) 
    {
	strcpy( option, awk(*fpvi, 1) );

	if ( !strcmp(option, "class") ) 
	{
	    classid++;	
	    class_default_mark=0;
	    
	    if (!strcmp(awk(*fpvi, 2), section)) 
	    {
		mydatablock = true;
		
		buf_ptr = new char[LONG_BUF];
		strcpy(buf_ptr, *fpvi);
		fpv_myclasses.push_back(buf_ptr);
		fpvi_tmp = fpvi;
		do {
		    if (!strcmp(awk(*fpvi_tmp, 1), "set-mark")) class_default_mark=atoi(awk(*fpvi_tmp,2));
		    fpvi_tmp++;		    
		} while ((fpvi_tmp != fpv_classfile.end()) && (strcmp(awk(*fpvi_tmp,1), "class")));
	    } 
	    else 
	    {
	        mydatablock = false;
	    }
	}	
	else if ( !strcmp(option, "match") ) 
	{
	    filterid++;	  	

    	    do {
	        is_protected = false;
	        for ( unsigned int n = protected_marks.size() ; n ; n-- ) 
	        {
	            if ( filterid == protected_marks[n-1] ) { is_protected = true; filterid++; }
	        }
	    } while ( is_protected );

	    if ( !mydatablock ) goto outside;

	    buf_ptr = new char[LONG_BUF];
	    sprintf ( buf,"%d",filterid );
	    strcpy ( buf_ptr , *fpvi );
	    strcat ( buf_ptr , " filterid " );
	    strcat ( buf_ptr , buf );

	    if ( class_default_mark )
	    {
		if (!strstr( *fpvi, " set-mark " ))
		{
		    sprintf ( buf,"%d", class_default_mark );
		    strcat ( buf_ptr , " set-mark " );
		    strcat ( buf_ptr , buf );
		}
	    }
	    else if ( strstr( *fpvi, " mark " ))
	    {
		sprintf ( buf,"%d", class_default_mark );
		strcat ( buf_ptr , " set-mark " );
		strcat ( buf_ptr , awk(strstr( *fpvi, " mark " ) ,2 ));
	    }

	    fpv_myclasses.push_back(buf_ptr);
	    
	    fpvi_tmp=fpvi;
	    fpvi_tmp++;
	    
	    if ( fpvi_tmp == fpv_classfile.end() ) default_param_should_be_inserted = true;
	    else if ( strcmp( awk(*fpvi_tmp, 1), "match") ) default_param_should_be_inserted = true;
	    else default_param_should_be_inserted = false;
	     
	    if ( default_param_should_be_inserted == false ) goto outside;
	    
            buf_ptr = new char[LONG_BUF];
            sprintf( buf_ptr, "%s", classtype );
            fpv_myclasses.push_back( buf_ptr );
    
    	    buf_ptr = new char[LONG_BUF];
    	    sprintf( buf_ptr, "low %d", default_low );
            fpv_myclasses.push_back( buf_ptr );
	    
    	    buf_ptr = new char[LONG_BUF];
	    sprintf( buf_ptr, "ceil %d", default_ceil );
	    fpv_myclasses.push_back( buf_ptr );
    	    
	    buf_ptr = new char[LONG_BUF];			
	    sprintf( buf_ptr, "prio %d", default_prio );
	    fpv_myclasses.push_back( buf_ptr );

	    buf_ptr = new char[LONG_BUF];			
	    sprintf( buf_ptr, "htb prio %d", default_htb_prio );
	    fpv_myclasses.push_back( buf_ptr );

	    buf_ptr = new char[LONG_BUF];			
	    sprintf( buf_ptr, "htb scheduler %s", scheduler );
	    fpv_myclasses.push_back( buf_ptr );

	    buf_ptr = new char[LONG_BUF];					
	    sprintf( buf_ptr, "hold %d", default_hold );
	    fpv_myclasses.push_back( buf_ptr );

	    buf_ptr = new char[LONG_BUF];					
	    sprintf( buf_ptr, "classid %d", classid );
	    fpv_myclasses.push_back( buf_ptr );

	    if ( sfq_perturb ) {
		buf_ptr = new char[LONG_BUF];			
	        sprintf( buf_ptr, "sfq perturb %d", sfq_perturb );
		fpv_myclasses.push_back( buf_ptr );
	    }	

	    if ( esfq_perturb ) {
		buf_ptr = new char[LONG_BUF];			
	        sprintf( buf_ptr, "esfq perturb %d", esfq_perturb );
		fpv_myclasses.push_back( buf_ptr );
	    }	

	    if ( strlen ( esfq_hash ) ) {
	        buf_ptr = new char[LONG_BUF];
		sprintf( buf_ptr, "esfq hash %s", esfq_hash );
		fpv_myclasses.push_back( buf_ptr );
	    }	
	
	    if ( imq_auto_redirect ) 
	    {
		buf_ptr = new char[LONG_BUF];
	        strcpy ( buf_ptr , "imq-redirect" );
	        fpv_myclasses.push_back( buf_ptr );
	    }
	
	    if ( ipt_return )
	    {
	        buf_ptr = new char[LONG_BUF];
		strcpy ( buf_ptr , "iptables return true" );
	        fpv_myclasses.push_back( buf_ptr );
	    }
	}
	else if ( mydatablock )
	{
	    buf_ptr = new char[LONG_BUF];
	    strcpy ( buf_ptr , *fpvi );
	    fpv_myclasses.push_back( buf_ptr );
	}
	outside:;
	fpvi++;
    }

    if ( !fpv_myclasses.size() ) { dump_error(23, ""); return -1; }
    
    fpvi=fpv_myclasses.begin();
    do {
	strcpy(option, awk(*fpvi, 1));
        if (!strcmp( option , "class" )) {
            section_classes++;
            tcclass.push_back(new classattrib);
        }
        if (tcclass[tcclass.size()-1]->store(*fpvi)==-1) {
    	    return -1;
        }	
        fpvi++;	
    } while ( fpvi != fpv_myclasses.end() );
  
    for (unsigned int i = 0; i < tcclass.size(); i++) {
	if ( tcclass[i]->prepare_tcclass() == -1 ) return -1;
    }

    gettimeofday(&ltt, NULL);
    sprintf(buf, "iptables -t mangle -N %s", ipt_mychain);
    system_ipt(buf);
  
    for (unsigned int i = 0; i < tcclass.size(); i++) {
	if (tcclass[i]->envinit() == -1) return -1;
    }
  
    for (unsigned int i = 0; i < net.size(); i++) { 
	if (net[i]->envinit() == -1) return -1; 
    }

    for ( int n=fpv_myclasses.size()-1; n>=0; n-- ) { delete [] fpv_myclasses.back(); fpv_myclasses.pop_back(); }

    return 0;
}

nsattrib::~nsattrib()
{
    char buf[LONG_BUF];

    for ( int n=net.size()-1; n>=0; n-- ) { delete net.back(); net.pop_back(); }
    for ( int n=tcclass.size()-1; n>=0; n-- ) { delete tcclass.back(); tcclass.pop_back(); }

    sprintf(buf, "iptables -t mangle -F %s 2> /dev/null > /dev/null", ipt_mychain);
    system_ipt(buf);
    sprintf(buf, "iptables -t mangle -X %s 2> /dev/null > /dev/null", ipt_mychain);
    system_ipt(buf);
}

void nsattrib::judge ()
{
    unsigned int old_section_rate=0;
    unsigned int tcclass_rate=0;    
    unsigned int section_rate=0;
    unsigned int section_rate_without_permill_bits = 0;
    bool tcclass_work;    
    register int i;
    int overload; 
    int overload_permill;  
    char buf[LONG_BUF];
    struct timeval now;
    float cycle_time;
    double intake_sum;
    double permill_bits_sum;
    FILE *fp;  
    vector < char * > iptables_summary;  
    vector < classattrib * > working_tcclass;  
    vector < classattrib * > changeable_tcclass;  
    classattrib * iterclass;

    gettimeofday(&now, NULL);
    cycle_time =  (float) (1000000 * (now.tv_sec - ltt.tv_sec) + now.tv_usec - ltt.tv_usec) / 1000000;
    gettimeofday(&ltt, NULL);
    sprintf(buf, "iptables -t mangle -L -Z %s -vnx", ipt_mychain);
    fp = popen(buf, "r");
    for ( unsigned int n=1; n<=2; n++ ) {
        if ( fgets(buf, LONG_BUF, fp) == NULL ) {
	    dump_error( 12, "" ); 
    	    pclose(fp);
	    return;
	}
    }
//    char * buf_ptr;  
//    while (( buf_ptr = fgets( new char[LONG_BUF], LONG_BUF, fp ))) {
//	iptables_summary.push_back(buf_ptr);  
//    }
//    pclose(fp);
    
    char * buf_ptr;                                                                                                                                            
    while ( fgets( buf, LONG_BUF, fp )) {                                                                                                                       
	buf_ptr = new char[LONG_BUF];                                                                                                                        
        strcpy ( buf_ptr , buf );                                                                                                                            
        iptables_summary.push_back(buf_ptr);                                                                                                                 
    }                                                                                                                                                          
    pclose(fp);      
    
  
    delete [] iptables_summary.back();
    iptables_summary.pop_back();

    unsigned int cycle_counter = 0;
    unsigned int not_changeable_section_rate = 0;
    section_rate = 0;
    section_rate_without_permill_bits = 0;
//    unsigned int perturbacja=0;
    do {
	if ( cycle_counter ) {
	    old_section_rate = section_rate;	    
	    section_rate = not_changeable_section_rate;
	    for ( i=changeable_tcclass.size()-1; i>=0; i-- ) {
		iterclass=changeable_tcclass[i]; 
		if ( iterclass->rate > iterclass->low ) {
		    if ( iterclass->rate <= iterclass->htb_ceil )
			section_rate += iterclass->rate - iterclass->low;		
		    else    
			section_rate += iterclass->htb_ceil - iterclass->low;
		}
	    }
	}
	else {
	    for ( i = tcclass.size()-1; i >= 0 ; i-- ) {
		iterclass=tcclass[i];
		tcclass_rate = iterclass->check( iptables_summary, now, cycle_time );
		tcclass_work = iterclass->work;

		if ( tcclass_rate || tcclass_work ) {
		    section_rate+=tcclass_rate;		   
		    working_tcclass.push_back( iterclass );	
		    if ( iterclass->rate <= iterclass->low ) {
			if ( iterclass->ceil != iterclass->low ) { 
			    not_changeable_section_rate+=iterclass->rate;    
			    changeable_tcclass.push_back( iterclass ); // klasa jest zmienialna poniewaz mozemy modyfikowac jej przydzial pasma
			}
			else {
			    not_changeable_section_rate+=iterclass->rate;
			}
		    }
		    else {
			changeable_tcclass.push_back( iterclass );
			not_changeable_section_rate+=iterclass->low;
		    }	
		}
	    }
	    if ( iptables_summary.size() ) {
		dump_error ( 12, "" );
        	return;
    	    }
	}

	if ( !working_tcclass.size()) break;

	intake_sum = 0;
	permill_bits_sum = 0;
	for ( i = changeable_tcclass.size()-1 ; i >= 0 ; i-- ) {
	    iterclass=changeable_tcclass[i];
	    if ( iterclass->rate <= iterclass->low ) {
		iterclass->intake=(double)(1)/(double)( iterclass->ceil - iterclass->low );
	    }
	    else if ( iterclass->rate <= iterclass->htb_ceil ) {
		iterclass->intake=(double)( iterclass->rate - iterclass->low )/(double)( iterclass->ceil - iterclass->low );
	    }
	    else if ( iterclass->rate > iterclass->htb_ceil ) {
		iterclass->intake=(double)( iterclass->htb_ceil - iterclass->low )/(double)( iterclass->ceil - iterclass->low );
	    }
	    intake_sum += iterclass->intake;
	    permill_bits_sum += iterclass->permill_bits*iterclass->intake;
	}

	overload = section_rate - section_shape;
//	overload_permill = (int)( (double(overload)) / permill_bits_sum );
	overload_permill = (int)( overload/permill_bits_sum );
	for ( i=changeable_tcclass.size()-1 ; i >= 0 ; i-- ) {
	    iterclass=changeable_tcclass[i];
	    if ( overload > 0 ) {
	//	if ( iterclass->prio >= cycle_counter ) {
	    	    iterclass->htb_ceil -= (int)( overload_permill * iterclass->permill_bits * iterclass->intake );
	//	}
	    }	
	    else {
	        iterclass->htb_ceil -= (int)( overload_permill * iterclass->permill_bits * ( intake_sum - iterclass->intake ));
	    }	
	}
	
	section_rate=not_changeable_section_rate;
	for ( i=changeable_tcclass.size()-1 ; i>=0 ; i-- ) {
	    iterclass=changeable_tcclass[i];	
	    if ( iterclass->htb_ceil > iterclass->ceil ) iterclass->htb_ceil = iterclass->ceil; 
	    if ( iterclass->htb_ceil < iterclass->low ) iterclass->htb_ceil = iterclass->low;

	    if ( iterclass->rate > iterclass->low ) {
	        if ( iterclass->rate < iterclass->htb_ceil )
	    	    section_rate += iterclass->rate - iterclass->low;
		else
		    section_rate += iterclass->htb_ceil - iterclass->low;
	    }
	}
	cycle_counter++;
	if ( cycle_counter == 16 ) break;
//	printf("shape:%d sr:%d osr:%d \n",section_shape, section_rate, old_section_rate);
    } while (( section_rate > section_shape ) && ( section_rate != old_section_rate ));
    
    working_tcclass.clear();
    changeable_tcclass.clear();
//    printf("workin_tcclass_sum:%d\n",working_tcclass.size());
//    printf("change_tcclass_sum:%d\n",changeable_tcclass.size());
//  printf("\n");


	    // perturbacja
/*	    perturbacja=0;
	    for ( i = changeable_tcclass.size()-1; i >= 0 ; i-- ) {
	    	iterclass=changeable_tcclass[i];
		perturbacja+=iterclass->htb_ceil*5/100;
		iterclass->htb_ceil-=iterclass->htb_ceil*5/100;
	    }
    	    
	    intake_sum = 0;
	    for ( i = changeable_tcclass.size()-1 ; i >= 0 ; i-- ) {
	        iterclass=changeable_tcclass[i];
	        if ( iterclass->rate <= iterclass->htb_ceil ) {
		    iterclass->intake=(double)( iterclass->rate - iterclass->low )/(double)( iterclass->ceil - iterclass->low ); 
		}
	        else {
	    	    iterclass->intake=(double)( iterclass->htb_ceil - iterclass->low )/(double)( iterclass->ceil - iterclass->low ); 
	        }
	        intake_sum += iterclass->intake;
	        permill_bits_sum += iterclass->permill_bits*iterclass->intake;		
	    }

	    //overload = section_rate - section_shape;
	    //overload_permill = (int)( (double(overload)) / permill_bits_sum );    
	    overload_permill = (int)( (double(perturbacja)) / permill_bits_sum );    
	    for ( i=changeable_tcclass.size()-1 ; i >= 0 ; i-- ) {
		iterclass=changeable_tcclass[i];
	        iterclass->htb_ceil += (int)( overload_permill * iterclass->permill_bits * ( intake_sum - iterclass->intake ));
	    }*/

	    // koniec perturbacji


    for ( i=tcclass.size()-1; i>=0 ; i--) {
	tcclass[i]->change();
    }
}

void nsattrib::stats( int pipe_write )
{
    char buf[LONG_BUF];

    sprintf( buf, "%s rate utilize\n", section );
    write( pipe_write, buf, strlen( buf ));
    for ( unsigned int i = 0; i < tcclass.size(); i++ ) {
	tcclass[i]->stats( pipe_write );
    }
}

