#include "instance.h"

instanceattrib::instanceattrib()
{
  int fd1[2], fd2[2];

  pipe(fd1);
  pipe(fd2);
  if ((pid = fork())) {
    i_am_parent = true;
    close(fd1[1]);
    close(fd2[0]);
    pipe_read = fd1[0];
    pipe_write = fd2[1];
    fcntl(pipe_read, F_SETFL, 0);
    fcntl(pipe_write, F_SETFL, 0);
    fcntl(fd1[0], F_SETFL, 0);
    fcntl(fd2[1], F_SETFL, 0);
  } else {
    i_am_parent = false;
    pid = getpid();
    close(fd2[1]);
    close(fd1[0]);
    pipe_read = fd2[0];
    pipe_write = fd1[1];
    fcntl(pipe_read, F_SETFL, 0);
    fcntl(pipe_write, F_SETFL, 0);
    fcntl(fd1[1], F_SETFL, 0);
    fcntl(fd2[0], F_SETFL, 0);
  }
}

instanceattrib::~instanceattrib()
{
  close(pipe_write);
  close(pipe_read);
}

void instanceattrib::kill_child()
{
  kill(pid, SIGTERM);
  waitpid(pid, NULL, 0);
}

void instanceattrib::sync()
{
  char buf;

  if (i_am_parent) {
    buf = 22;
    write(pipe_write, &buf, 1);
    do {
      read(pipe_read, &buf, 1);
    } while (buf != 22);
  } 
  else {
    do {
      read(pipe_read, &buf, 1);
    } while (buf != 22);
    buf = 22;
    write(pipe_write, &buf, 1);
  }
}

void instanceattrib::send_init_status_ok()
{
  char buf = 6;

  write(pipe_write, &buf, 1);
}

void instanceattrib::send_init_status_error()
{
  char buf = 21;

  write(pipe_write, &buf, 1);
}

int instanceattrib::get_init_status()
{
  char buf;

  do {
    read(pipe_read, &buf, 1);
  } while ((buf != 6) && (buf != 21));
  if (buf == 6) return 0;
  else return -1;
}

void instanceattrib::send_result(nsattrib * ns)
{
  ns->stats(pipe_write);

  char _buf_ = 4;
  write(pipe_write, &_buf_, 1);
}

void instanceattrib::send_continue()
{
  char _buf_ = 26;
  write(pipe_write, &_buf_, 1);
}

void instanceattrib::get_result()
{
    char buf_ , *buf;
    int n=0;

    read( pipe_read, &buf_ , 1 );  
    if ( buf_ == 26 ) return;
    
    for ( int n=stats_container.size()-1; n>=0; n-- )
    {
	delete [] stats_container.back();
	stats_container.pop_back();    
    }

//    for ( unsigned int n=0 ; n<stats_container.size() ; n++ )                                                                                                  
//    {                                                                                                                                                          
//	delete stats_container[n];                                                                                                                               
//    }                                                                                                                                                          
//    stats_container.clear();   

    buf = new char[80];
    while ( buf_ != 4 ) {
	buf[n]=buf_;
	if ( buf_ == '\n' ) {
	    trim(buf);
	    stats_container.push_back (buf);
	    buf = new char[80];
	    n=0;
	}
	else {
	    n++;
	}
	read( pipe_read, &buf_ , 1 );  
    } 						      
}
void instanceattrib::dump_stats(int fd)
{
  char buf[81], buf2[81], *one_line;

  for (unsigned int n = 0; n < stats_container.size(); n++) {
    one_line = stats_container[n];
    if (n) {
      sprintf(buf, "%-16.16s  ", awk(one_line, 1));
      strcpy(buf2, "" );      
      if ( strcmp( awk(one_line, 2), "-" ) ) {
        sprintf(buf2, "%8d%s - ", (int) unitconvert(atoi(awk(one_line, 2)), statsunit), chstatsunit);
      }	
      else {
        for ( unsigned int i=0 ; i < 8+strlen (chstatsunit) ; i++ ) strcat (buf2," ");
        strcat (buf2, "   ");	
      }
      strcat(buf, buf2);
      strcpy(buf2, "" );            
      if ( strcmp( awk(one_line, 3), "-" ) ) {
        sprintf(buf2, "( %8d%s )\n", (int) unitconvert(atoi(awk(one_line, 3)), statsunit),  chstatsunit);
      }
      else {
        strcat(buf2, "( " );           
        for ( unsigned int i=0 ; i < 8+strlen (chstatsunit) ; i++ ) strcat (buf2," ");
        strcat(buf2, " )\n" );           	
      }	
      strcat(buf, buf2);     
    } 
    else {
      sprintf(buf, "%-16.16s  ", awk(one_line, 1));
      for (unsigned int n = 0; n < strlen(chstatsunit); n++) { strcat(buf, " "); }
      sprintf(buf2, "%8s - (", awk(one_line, 2));
      strcat(buf, buf2);
      for (unsigned int n = 0; n < strlen(chstatsunit); n++) { strcat(buf, " "); }
      sprintf(buf2, " %8s )\n", awk(one_line, 3));
      strcat(buf, buf2);
    }
    write(fd, buf, strlen(buf));
  }
  sprintf(buf, "\n");
  write(fd, buf, strlen(buf));
}
