#include "niceshaper.h"
#include "instance.h"
#include "class_container.h"

char conffile[MAX_PATH]="/etc/niceshaper0.6/config";
char classfile[MAX_PATH]="/etc/niceshaper0.6/class";
char statsfile[MAX_PATH] = "/tmp/niceshaper.stats";
char statsflag[MAX_PATH] = "/tmp/niceshaper.stats.flag";
char pidfile[MAX_PATH] = "/var/run/niceshaper.pid";

char section[SHORT_BUF];
char ipt_mychain[SHORT_BUF];
char ipt_myparent[SHORT_BUF]="";
char ipt_myparent_mode[SHORT_BUF];

unsigned int working = 0;
unsigned int section_htb_ceil = 0;
unsigned int section_shape = 0;
unsigned int section_interactive_sum = 0;
unsigned int section_id = 0;
unsigned int section_max_permills = 1000;
unsigned int section_classes = 0;

langtype lang = en;
unittype statsunit = kbps;
char chstatsunit[8] = "kB/s";
char markifaces[LONG_BUF];
bool overload;
bool debug_ipt = false;
bool debug_tc = false;
bool i_am_parent;
bool daemon_mode = true;
bool fatal_error = false;

class nsattrib *ns;
class instanceattrib *parent_instance = NULL;

vector < char * > fpv_conffile,fpv_classfile;  
vector < instanceattrib * >instance;
vector < unsigned int > protected_marks;

struct ifa {
    char path[MAX_PATH]; 
    char type[SHORT_BUF]; 
    char section_download [SHORT_BUF];
    char section_upload [SHORT_BUF];
    char iface_inet [MAX_IFACE];
    bool resolve_hostname;
} include_file_attrib;

int main(int argc, char *argv[])
{
    char sessions[LONG_BUF] = "", buf[LONG_BUF] = "", option[SHORT_BUF] = "";
    char statsfileowner[SHORT_BUF] = "root";
    char statsfilegroup[SHORT_BUF] = "root";
    char statsfilemode[SHORT_BUF] = "644";
    char statspath[MAX_PATH] = "";  
    bool dump_stats = false;
    vector < char * >::iterator fpvi, fpvi_begin, fpvi_end, fpvi_tmp;
    struct timeval now, past;
    int fd;
    FILE *fp;
    int n;
    unsigned int m;
    unsigned int reload = 50;
    unsigned int reload_quantum = 100000;
    float frel = 0;

    run( argc, argv );

    if (daemon_mode) {
	if (fork()) {
	    while ( access( pidfile, 0 )) usleep(100000);
  	    usleep(100000);
  	    exit(0);
	}
    }

    fp = fopen( conffile, "r" );
    fseek(fp, 0, SEEK_SET);
    if ( conv_to_fpv ( fpv_conffile, fp , conftype , true , sessions ) == -1 ) fatal_error=true;
    fclose(fp);
    
    if ( fatal_error ) {
	creat(pidfile, 0660);
	usleep(200000);
	unlink(pidfile);
	exit(-1);
    }

    fpv_section_i( fpvi_begin, fpvi_end, fpv_conffile, "global" );
    fpvi=fpvi_begin;
    while ( fpvi != fpvi_end ) {
	strcpy ( buf , *fpvi );
	fpvi++;
	strcpy(option, awk(buf, 1));
	
	if (!strcmp(option, "stats")) 
	{
  	    if (strstr(buf, "unit")) 
	    {
  		statsunit = getunit(awk(strstr(buf, "unit"), 2));
		strcpy(chstatsunit, awk(strstr(buf, "unit"), 2));
	    }
  	    if (strstr(buf, "file")) 
	    {
		strcpy(statspath, awk(strstr(buf, "file"), 2));
		if (!strcmp(statspath, "none") || !strcmp(statspath, "false") || !strlen(statspath)) {
	  	    dump_stats = false;
		}
		else {
		  dump_stats = true;
		}
	    }
	    if (strstr(buf, "owner")) {
		strcpy(statsfileowner, awk(strstr(buf, "owner"), 2));
  	    }
  	  if (strstr(buf, "group")) {
		strcpy(statsfilegroup, awk(strstr(buf, "group"), 2));
  	  }
  	  if (strstr(buf, "mode")) {
		strcpy(statsfilemode, awk(strstr(buf, "mode"), 2));
  	  }
	} 
	else if (!strcmp(option, "run")) {
	    n = 2;
    	    while (strlen(awk(buf, n))) {
  		strcat(sessions, awk(buf, n));
		strcat(sessions, " ");
		n++;
	    }	
	} 
	else if (!strcmp(option, "lang")) {	
	  if ( !strcmp ( awk(buf,2) , "en" )) lang=en;	
	  else if ( !strcmp ( awk(buf,2) , "pl" )) lang=pl;	
	  else lang=en;
	}
	else if (!strcmp(option, "support")) 
	{
  	    if (strstr(buf, "mark-on")) 
	    {
		strcpy(markifaces, "");
		n = 3;
		while (strlen(awk(buf, n))) {
    		    strcat(markifaces, awk(buf, n));
    		    strcat(markifaces, " ");
    		    n++;
		}
	    }
	}    
	else if (!strcmp(option, "support")) {
	    if (!strcmp(awk(buf, 2), "mark")) {
    		if (!strcmp(awk(buf, 3), "on")) {
    		    strcpy(markifaces, "");
		    n = 4;
    		    while (strlen(awk(buf, n))) {
	    		strcat(markifaces, awk(buf, n));
		        strcat(markifaces, " ");
	    	        n++;
		    }
  		}
	    }
	}															
    }	 
    
    if ( !strlen ( sessions )) {
	dump_error( 15, "" );
	creat(pidfile, 0660);
	usleep(200000);
	unlink(pidfile);
	exit(1);
    }

    n = 1;
    while (strlen(awk(sessions, n))) 
    {
        fpv_section_i(fpvi_begin, fpvi_end, fpv_conffile, awk(sessions, n));
        fpvi=fpvi_begin;
    	while ( fpvi != fpvi_end ) {
	    strcpy ( buf , *fpvi );
	    fpvi++;
	    strcpy(option, awk(buf, 1));
	    if (!strcmp(option, "reload")) 
	    {
        	reload = (unsigned int)(strtof(awk(buf, 2), NULL)*10);  
            	if (( reload == 0 ) || ( reload > 6000 ))                 
            	{                                                                                                                                            
		    dump_error ( 13, "");
	    	    creat(pidfile, 0660);
	    	    usleep(200000);
		    unlink(pidfile);
		    exit(1);
	        }
	    }
	}
	frel += 1/(float)reload;
	n++;
    }
    
    reload_quantum=(unsigned int)(100000/frel);
    
    fp = fopen(classfile, "r");
    fseek(fp, 0, SEEK_SET);
    if ( conv_to_fpv ( fpv_classfile, fp , classtype , true , sessions ) == -1 ) {
	fclose(fp);
	creat(pidfile, 0660);
	usleep(200000);
	unlink(pidfile);
	exit(1);
    }
    fclose(fp);

    system_ipt ("for n in `iptables -t mangle -L PREROUTING -nv --line-numbers | grep ns_ | awk '{print $1}' | sort -r`; do iptables -t mangle -D PREROUTING $n ; done");
    system_ipt ("for n in `iptables -t mangle -L POSTROUTING -nv --line-numbers | grep ns_ | awk '{print $1}' | sort -r`; do iptables -t mangle -D POSTROUTING $n ; done");
    system_ipt ("for n in `iptables -t mangle -L INPUT -nv --line-numbers | grep ns_ | awk '{print $1}' | sort -r`; do iptables -t mangle -D INPUT $n ; done");
    system_ipt ("for n in `iptables -t mangle -L OUTPUT -nv --line-numbers | grep ns_ | awk '{print $1}' | sort -r`; do iptables -t mangle -D OUTPUT $n ; done");
    system_ipt ("for n in `iptables -t mangle -L FORWARD -nv --line-numbers | grep ns_ | awk '{print $1}' | sort -r`; do iptables -t mangle -D FORWARD $n ; done");
    system_ipt ("for n in `iptables -t mangle -L -nv | grep 'Chain ns_' | awk '{print $2}'`; do iptables -t mangle -F $n ; iptables -t mangle -X $n;  done");

    n = 1;
    char tag[LONG_BUF];
    char dev[MAX_IFACE];
    char buf2[LONG_BUF];    
  
    while (strlen(awk(sessions, n))) {
	strcpy(tag, awk(sessions, n));  
        fpv_section_i( fpvi_begin, fpvi_end, fpv_conffile, tag );
        fpvi = fpvi_begin;
        while ( fpvi != fpvi_end ) {
    	    strcpy ( buf , *fpvi );
    	    fpvi ++;
    	    strcpy(option, awk(buf, 1));
    	    if (!strcmp(option, "iface")) {
		strcpy( buf2, "" );
	        strcpy( dev , awk(buf, 2) );
		if ( valid_dev (dev) == -1 ) {
		    dump_error( 16, buf );
		    creat(pidfile, 0660);
		    usleep(200000);
		    unlink(pidfile);
		    exit(0);
		}
		sprintf(buf2, "tc qdisc del root dev %s 2> /dev/null > /dev/null", dev);
	        system_tc(buf2);
		sprintf(buf2, "tc qdisc add dev %s root handle 1: htb default 1", dev);
		system_tc(buf2);
		sprintf(buf2, "tc class add dev %s parent 1: classid 1:1 htb rate 100mbit quantum 8738", dev);
		system_tc(buf2);
	    } 
	}
	n++;
    }

    n = 1;
    signal(SIGTERM, signalterm);
    signal(SIGINT, signalterm);
    while (strlen(awk(sessions, n))) {
	strcpy(section, awk(sessions, n));
	section_id = 10 + n;
	instance.push_back(new instanceattrib());
	if (i_am_parent) {
	    if (instance.back()->get_init_status() == -1) {
		creat(pidfile, 0660);
  		usleep(200000);
  		unlink(pidfile);
    		strcpy(section, "global");	
		signalterm(SIGTERM);	  
	    }
	} 
	else {
	    parent_instance = instance.back();
	    sprintf(ipt_mychain, "ns_%s", section);
	    if ( !strcmp ( section,"download") ) chdir("/");
	    break;
	}
	n++;
    }
  
    if (i_am_parent) {
	sprintf(buf, "%d", getpid());
	fd = creat(pidfile, 0660);
	write(fd, buf, strlen(buf));
	close(fd);
        strcpy(section, "global");
	printf("\n");
	if ( dump_stats ) {
	    unlink(statspath);
	    fd = creat(statspath, O_WRONLY);
	    sprintf(buf, "chown %s:%s %s && chmod %s %s &", statsfileowner, statsfilegroup, statspath, statsfilemode, statspath);
	    system(buf);
	    close(fd);
	}

	m = instance.size();

	for ( int n=fpv_conffile.size()-1; n>=0; n-- ) { delete [] fpv_conffile.back(); fpv_conffile.pop_back(); }
        for ( int n=fpv_classfile.size()-1; n>=0; n-- ) { delete [] fpv_classfile.back(); fpv_classfile.pop_back(); }

	while (true) {
	    for ( unsigned int n=0; n<m; n++ ) {
		instance[n]->sync();
		instance[n]->get_result();
		if ( !access( statsflag, 0 )) {
    		    unlink( statsfile );
		    fd=creat( statsfile, 0660 );
		    for ( unsigned int n=0; n<m; n++ ) instance[n]->dump_stats(fd);
		    close(fd);
		    unlink(statsflag);
		}
		if ( dump_stats ) {
		    fd = open( statspath, O_RDWR | O_TRUNC );
		    for ( unsigned int n=0; n<m; n++ ) instance[n]->dump_stats(fd);
		    strcpy( buf, "                                Powered by NiceShaper\n" );
		    write( fd, buf, strlen(buf));
		    strcpy( buf, "                       http://niceshaper.jedwabny.net\n" );
		    write( fd, buf, strlen(buf));
		    close(fd);
		}
	    }
	}
    }
    else {
	unsigned long int cycle;
	ns = new nsattrib();
	//chdir("/");
	if ( ns->init( fpv_conffile, fpv_classfile ) == -1 ) {
	    if ( lang==pl ) printf("\tNiceShaper: nie mozna bylo uruchomic sekcji %s....\n", section);	  
	    else printf("\tNiceShaper: CAN NOT start section %s....\n", section);	  
	    parent_instance->send_init_status_error();
	    usleep(1000000);
	} 
	else {
	    if ( lang==pl ) printf("\tNiceShaper: uruchamianie sekcji %s....\n", section);
	    else printf("\tNiceShaper: Starting section %s....\n", section);	  
	    parent_instance->send_init_status_ok();
        }
	
	for ( int n=fpv_conffile.size()-1; n>=0; n-- ) { delete [] fpv_conffile.back(); fpv_conffile.pop_back(); }
        for ( int n=fpv_classfile.size()-1; n>=0; n-- ) { delete [] fpv_classfile.back(); fpv_classfile.pop_back(); }

	gettimeofday( &past, NULL );
	m = ns->get_reload();
        while (true) {
	    usleep (reload_quantum);
	    gettimeofday( &now, NULL );
	    cycle=(now.tv_sec-past.tv_sec)*10 + (now.tv_usec-past.tv_usec)/100000;
	    if ( cycle >= m ) {
		ns->judge();
		parent_instance->sync();
    	        parent_instance->send_result(ns);
    		gettimeofday(&past, NULL);        
	    }
	    else {
		parent_instance->sync();
    		parent_instance->send_continue();
	    }
	} 
    }
    return 0;
}

void run(int argc, char *argv[])
{
    int dpid, fd;
    char buf[LONG_BUF];
    struct timeval now;
    bool force_overwrite_pidfile = false;  
    char usersfile[MAX_PATH]="/etc/niceshaper0.6/users";
    char usersfile_mode[MAX_PATH]="";
    char outputfile[MAX_PATH]="";
    char section_download[MAX_PATH]="";
    char section_upload[MAX_PATH]="";
    char iface_inet[MAX_IFACE]="";
    bool resolve_hostname=false;
    vector < char * > fpv;  
    vector < char * >::iterator fpvi, fpvi_end;
    FILE *fp;

    if (argc==1) { help(); exit(0); }

    for ( int n=2; n<argc; n++ ) {
	if ( string(argv[n]) == "--confdir" ) {
	    sprintf( conffile, "%s/config", argv[n+1] );
	    sprintf( classfile, "%s/class", argv[n+1] );
	    sprintf( usersfile, "%s/users", argv[n+1] );
	}
    }
    
    for ( int n=2; n<argc; n++ ) {
	if ( string(argv[n]) == "--conffile" ) { 
	    if ( (n+1)>=argc ) { dump_error( 28, argv[n] ); exit(0); }
	    strcpy( conffile, argv[++n] ); 
	    if ( file_is_readable(conffile) == -1 ) dump_error( 26, conffile );
	}
	else if ( string(argv[n]) == "--classfile" ) { 
	    if ( (n+1)>=argc ) { dump_error( 28, argv[n] ); exit(0); }
	    strcpy( classfile, argv[++n] ); n++; 
	    if ( file_is_readable(classfile) == -1 ) dump_error( 26, classfile );
	}
	else if ( string(argv[n]) == "--simple-usersfile" ) { 
	    if ( (n+1)>=argc ) { dump_error( 28, argv[n] ); exit(0); }
	    strcpy( usersfile, argv[++n] ); 
	    strcpy( usersfile_mode, "simple" ); 	    
	    if ( !strlen( usersfile )) { dump_error( 28, argv[n] ); exit(0); };
	}
	else if ( string(argv[n]) == "--extended-usersfile" ) { 
	    if ( (n+1)>=argc ) { dump_error( 28, argv[n] ); exit(0); }
	    strcpy( usersfile, argv[++n] ); 	    
	    strcpy( usersfile_mode, "extended" ); 
	    if ( !strlen( usersfile )) { dump_error( 28, argv[n] ); exit(0); };
	}
	else if ( string(argv[n]) == "--outfile" ) { 
	    if ( (n+1)>=argc ) { dump_error( 28, argv[n] ); exit(0); }
	    strcpy( outputfile, argv[++n] );  
	}
	else if ( string(argv[n]) == "--download-section" ) { 
	    if ( (n+1)>=argc ) { dump_error( 28, argv[n] ); exit(0); }
	    strcpy( section_download, argv[++n] ); 
	    if ( !strlen(section_download )) { dump_error( 28, "--section-download" ); exit(0); };
	}	
	else if ( string(argv[n]) == "--upload-section" ) { 
	    if ( (n+1)>=argc ) { dump_error( 28, argv[n] ); exit(0); }
	    strcpy( section_upload, argv[++n] );  
	    if ( !strlen(section_upload )) { dump_error( 28, "--section-upload" ); exit(0); };
	}
	else if ( string(argv[n]) == "--iface-inet" ) {
	    if ( (n+1)>=argc ) { dump_error( 28, argv[n] ); exit(0); }
	    strcpy( iface_inet, argv[++n] );	
    	    if ( valid_dev(iface_inet)==-1) { dump_error( 28, "--iface-inet" );	exit(0); }
	}
	else if ( string(argv[n]) == "--resolve-hostname" ) { 
	    if ( (n+1)>=argc ) { dump_error( 28, argv[n] ); exit(0); }
	    else if ( !strcmp( argv[++n], "true" )) resolve_hostname=true; 
	    else resolve_hostname=false;
	}	
	else if ( string(argv[n]) == "--no-daemon" ) { 
	    daemon_mode=false; 
	}
	else if ( string(argv[n]) == "--force-pidfile" ) { 
	    force_overwrite_pidfile=true; 
	}
	else dump_error( 28, argv[n] );
	
	if ( fatal_error ) exit(0);
    }

    if ( string(argv[1]) == "convert" ) {
	if ( strlen(outputfile) && !access( outputfile, 0 )) {
	    gettimeofday( &now, NULL );
	    sprintf( buf, "%s.%lu", outputfile, now.tv_sec );
	    if ( lang==pl ) printf( "\n\tplik %s juz istnieje,\njego nazwa zostanie zmieniona na:'%s'\n\n", outputfile, buf );
	    else printf( "\n\tfile %s already exist,\nit will rename to:'%s'\n\n", outputfile, buf );
	    rename( outputfile, buf );
	}

        fp=fopen( conffile, "r" );
	fseek(fp, 0, SEEK_SET);
	if ( conv_to_fpv ( fpv_conffile, fp , conftype , true , "" ) == -1 ) fatal_error=true;
	fclose(fp);

	fp=fopen( usersfile, "r" );
	if ( !strcmp( usersfile_mode, "simple" )) convert_simple_usersfile ( fpv, fp , iface_inet, section_download, section_upload, NULL, resolve_hostname, true );
	else if ( !strcmp( usersfile_mode, "extended" )) convert_extended_usersfile ( fpv, fp, NULL, resolve_hostname, true );
	fclose(fp);

        if ( strlen(outputfile)) fd = creat( outputfile, 0660 );
        fpvi=fpv.begin();             
        fpvi_end=fpv.end();
        while ( fpvi != fpvi_end ) {
    	    if ( strlen(outputfile)) { write( fd, *fpvi, strlen(*fpvi) ); write( fd, "\n", 1 ); }
	    else printf( "%s\n", *fpvi );
	    fpvi++;
	}
	if ( strlen(outputfile)) close(fd);
	exit(0);
    } 
    else if (( string(argv[1]) == "stop") || ( string(argv[1]) == "restart" )) {
	if ( access( pidfile, 0 )) {
	    if ( lang==pl ) printf ( "\n\tNiceShaper nie jest uruchomiony...( nie znaleziono pliku /var/run/niceshaper.pid file)\n\n ");
	    else printf ( "\n\tNiceShaper is not running...( there is not /var/run/niceshaper.pid file)\n\n" );
	    exit(0);
	}
	fd = open( pidfile, 0660 );
        dpid = read( fd, buf, 8 );
        buf[dpid] = '\0';
        dpid = atoi(buf);
        close(fd);
        kill( dpid, SIGTERM );
        while ( !access( pidfile, 0 )) usleep(100000);
	printf("\n\tok\n\n");
	if ( !strcmp( argv[1], "stop" )) exit(0);
    } 
    else if ( string(argv[1]) == "stats" ) {
	char buf[10];
        int fd;
	if ( access( pidfile, 0 )) {
	    if ( lang==pl ) printf ( "\n\tNiceShaper nie jest uruchomiony...( nie znaleziono pliku /var/run/niceshaper.pid file)\n\n" );
	    else printf ( "\n\tNiceShaper is not running...( there is not /var/run/niceshaper.pid file)\n\n" );	  
	    exit(0);
	}
	creat( statsflag, 0660 );
        while ( !access( statsflag, 0 )) usleep(100000);
        while ( access( statsfile, 0 )) usleep(100000);
        fd = open( statsfile, 0660 );
        while ( read( fd, buf, 1 )) printf( "%c", buf[0] );
        close(fd);
        exit(0);
    }
    if (( string(argv[1]) != "start" ) && ( string(argv[1]) != "restart" )) {
	help();
        exit(0);
    }
    if ( !access( pidfile, 0 )) {
        if (force_overwrite_pidfile) {
	    unlink(pidfile); 
	}
	else {	
	    if (lang==pl) {
	        printf ( "\n\tNiceShaper jest juz uruchomiony...( znaleziono plik /var/run/niceshaper.pid file) \n" );
	        printf ( "\tmozesz uzyc opcji --force-pidfile jesli wiesz co robisz!!\n\n" );
	    }    
	    else {
		printf ( "\n\tNiceShaper alredy running...( there is /var/run/niceshaper.pid file) \n" );
	        printf ( "\tYou can use --force-pidfile but be carefully!!!\n\n" );	
    	    }		
	    exit(0);
	}
    }
    if ( access( classfile, R_OK )) {
	if ( lang==pl ) printf( "\n\todczytanie pliku %s nie powiodlo sie\nwychodze...\n\n", classfile );
	else printf( "\n\tcan't read %s file\nquit...\n\n", classfile );
	exit(0);
    }
    if ( access( conffile, R_OK )) {
	if ( lang==pl ) printf( "\n\todczytanie pliku %s nie powiodlo sie\nwychodze...\n\n", conffile );	
	else printf( "\n\tcan't read %s file\nquit...\n\n", conffile );	
	exit(0);
    }
    printf( "\n\tNiceshaper version:%s\n\thttp://niceshaper.jedwabny.net\n\n", version );
}
void signalterm( int sig )
{
    signal( SIGTERM, signalterm );

    if ( i_am_parent ) {
	for ( unsigned int n=0; n<instance.size(); n++ ) {
	    instance[n]->kill_child();
	    delete instance[n];
	}
	instance.clear();
	unlink(pidfile);
    } 
    else {
        delete ns;
        delete parent_instance;
    }
    if ( lang==pl ) printf( "\n\tOpuszczam %s...\n", section );
    else printf( "\n\tQuit %s instance...\n", section );
    exit(0);
  
}
int dotobit( char mask[] )
{
  unsigned long addr;
  int n, bit;

  addr=ntohl( inet_addr(mask));
  for ( n=0, bit=0; n<32; n++ )
    bit += (addr>>n)&1;
  return bit;
}

bool bitodot(char mask[], int arg)
{
  struct in_addr netwrk;
  int n, m;

  if (arg < 0 || arg > 32) return false;
  for (m = 0, n = 0; n < arg; n++) m += 1 << (31 - n);
  netwrk.s_addr = htonl(m);
  strcpy( mask, inet_ntoa(netwrk));
  mask[strlen(mask)] = '\0';
  return true;
}

enum unittype getunit(char arg[])
{
    if ( strstr( arg, "kbit" )) return kbit;
    else if ( strstr( arg, "mbit" )) return mbit;
    else if ( strstr( arg, "bit" )) return bit;

    else if ( strstr( arg, "kB" )) return kbps;
    else if ( strstr( arg, "mB" )) return mbps;
    else if ( strstr( arg, "B" )) return bps;

    else if ( strstr( arg, "kbps" )) return kbit;
    else if ( strstr( arg, "mbps" )) return mbit;
    else if ( strstr( arg, "bps" )) return bit;

    else if ( strstr( arg, "kBps" )) return kbps;
    else if ( strstr( arg, "mBps" )) return mbps;
    else if ( strstr( arg, "Bps" )) return bps;

    else if ( strstr( arg, "kb/s" )) return kbit;
    else if ( strstr( arg, "mb/s" )) return mbit;
    else if ( strstr( arg, "b/s" )) return bit;

    else if ( strstr( arg, "kB/s" )) return kbps;
    else if ( strstr( arg, "mB/s" )) return mbps;
    else if ( strstr( arg, "B/s" )) return bps;

    else return bit;
}

long int unitconvert(char arg[], unittype resunit)
{
  return ((atol(arg) * (long int) getunit(arg)) / (long int) resunit);
}
long int unitconvert(long int arg, unittype resunit)
{
  return (arg / (long int) resunit);
}

int gen_ipt_filter (char result_buf[], char src_buf[])
{
    char addr[SHORT_IP_ADDR];
    char mask[SHORT_IP_ADDR];
    char value[SHORT_BUF]="";

    if (strstr(src_buf, " proto ")) {
	strcpy(value, awk(strstr(src_buf, " proto "), 2 ) );    
	strcat(result_buf, " -p ");
	strcat(result_buf, value);
        strcat(result_buf, " ");
    }
    
    if (strstr(src_buf, " srcip ")) {
    	strcpy( value, awk(strstr(src_buf, " srcip "), 2 ) );    
	if ( split(addr, mask, value ) == -1 ) return -1;
	strcat(result_buf, " -s ");
	strcat(result_buf, addr);
        strcat(result_buf, "/");
        strcat(result_buf, mask);
        strcat(result_buf, " ");	
    }
    if (strstr(src_buf, " dstip ")) {
	strcpy(value, awk(strstr(src_buf, " dstip "), 2 ) );        
	if (split(addr, mask, value) == -1) return -1;
        strcat(result_buf, " -d ");
        strcat(result_buf, addr);
        strcat(result_buf, "/");
        strcat(result_buf, mask);
        strcat(result_buf, " ");	
    }
    if (strstr(src_buf, " srcport ")) {
	strcpy(value, awk(strstr(src_buf, " srcport "), 2 ) );            
        strcat(result_buf, " --sport ");
        strcat(result_buf, value);
        strcat(result_buf, " ");
    }
    else if (strstr(src_buf, " sport ")) {
	strcpy(value, awk(strstr(src_buf, " sport "), 2 ));
	strcat(result_buf, " --sport ");
        strcat(result_buf, value);
        strcat(result_buf, " ");
    }
    if (strstr(src_buf, " dstport ")) {
	strcpy(value, awk(strstr(src_buf, " dstport "), 2 ) );            
	strcat(result_buf, " --dport ");
        strcat(result_buf, value);
	strcat(result_buf, " ");
    }
    else if (strstr(src_buf, " dport ")) {
	strcpy(value, awk(strstr(src_buf, " dport "), 2 ) );            
	strcat(result_buf, " --dport ");
	strcat(result_buf, value);
	strcat(result_buf, " ");
    }
							
    if (strstr( src_buf, " state ")) {
	strcpy ( value, awk(strstr(src_buf, " state "), 2 ));
        if (( strcmp( value, "new")) && ( strcmp( value, "established")) && ( strcmp( value, "related")) && 
	   ( strcmp( value, "invalid")) && ( strcmp( value, "untracked"))) {
    		if ( lang == pl ) printf("\n\t%s: bledny stan: %s\n", section, src_buf); 
    		else printf("\n\t%s: invalid state: %s\n", section, src_buf); 
    		return -1; 
        }
	strcat(result_buf, " -m state --state " );
	strcat(result_buf, value);
	strcat(result_buf, " ");
    }
    else if (strstr(src_buf, " tos ")) {
	strcpy(value, awk(strstr(src_buf, " tos "), 2 ) );
	strcat(result_buf, " -m tos --tos ");
	strcat(result_buf, value);
	strcat(result_buf, " ");
    }
    else if (strstr(src_buf, " ttl-lower ")) {
	strcpy(value, awk(strstr(src_buf, " ttl-lower "), 2 ) );
	strcat(result_buf, " -m ttl --ttl-lt ");
	strcat(result_buf, value);
	strcat(result_buf, " ");
    }
    else if (strstr(src_buf, " ttl-greater ")) {
	strcpy(value, awk(strstr(src_buf, " ttl-greater "), 2 ) );            
	strcat(result_buf, " -m ttl --ttl-gt ");
        strcat(result_buf, value);
        strcat(result_buf, " ");
    }
    else if (strstr(src_buf, " ttl ")) {
	strcpy(value, awk(strstr(src_buf, " ttl "), 2 ) );            
	strcat(result_buf, " -m ttl --ttl ");
	strcat(result_buf, value);
	strcat(result_buf, " ");
    }    
    else if (strstr(src_buf, " mark ")) {
	strcpy(value, awk(strstr(src_buf, " mark "), 2 ) );            
	strcat(result_buf, " -m mark --mark ");
	strcat(result_buf, value);
	strcat(result_buf, " ");
    }	
    return 1;	   												
}

char *awk(char param[], unsigned int word)
{
    unsigned int n, aku;
    char buf[128];
    static char result[128];
    unsigned int paramlength;

    aku = 0;
    strcpy(buf, "");
    strcpy(result, "");
    paramlength = strlen(param);    
    for (n = 0; n + 1 < paramlength; n++) {
	if ((param[n] == 32 || param[n] == 9) && (param[n + 1] != 32 && param[n + 1] != 9)) aku++;
	if (n == 0 && param[0] != 32 && param[0] != 9) aku++;
	if (aku == word) {
	    if (n == 0 && param[0] != 32 && param[0] != 9)
	    strcpy(buf, param);
	else
	    strcpy(buf, &(param)[n + 1]);
	    break;	    
	}
    }
    paramlength = strlen(buf);
    for (n = 0; n < paramlength; n++) {
	if (buf[n] == 32 || buf[n] == 9 || buf[n] == 10) {
	    buf[n] = '\0';
	    break;
	}
    }
    strcpy(result, buf);
    
    if (strlen(result)) return result;
    else return "";

    return result;
}

char *awk2(char param[], unsigned int word)
{
    unsigned int n, aku;
    char buf[128];
    static char result[128];

    aku = 0;
    strcpy(buf, "");
    strcpy(result, "");
    unsigned int paramlength = strlen(param);        
    for (n = 0; n + 1 < paramlength; n++) {
	if ((param[n] == 32 || param[n] == 9) && (param[n + 1] != 32 && param[n + 1] != 9)) aku++;
	if (n == 0 && param[0] != 32 && param[0] != 9) aku++;
	if (aku == word) {
	    if (n == 0 && param[0] != 32 && param[0] != 9)
	    strcpy(buf, param);
	else
	    strcpy(buf, &(param)[n + 1]);
	    break;
	}
    }
    for (n = 0; n < strlen(buf); n++) {
	if (buf[n] == 32 || buf[n] == 9 || buf[n] == 10) {
	    buf[n] = '\0';
	    break;	    
	}
    }
    strcpy(result, buf);
    
    if (strlen(result)) return result;
    else return "";

    return result;
}

bool getip(char netaddr[], char dev[])
{
    char buf[256];
    FILE *pp;

    strcpy(netaddr, "");
    strcpy(buf, "");
    sprintf(buf, "ip addr show dev %s", dev);
    pp = popen(buf, "r");
    while (fgets(buf, LONG_BUF, pp)) {
	if (!strcmp(awk(buf, 1), "inet")) {
	    strcpy(netaddr, awk(buf, 2));
	    pclose(pp);
	    return true;
	}
    }
    
    pclose(pp);
    return false;
}
void iptohostname(char hostname[], char ipaddr[])
{
    uint32_t addr;
    struct hostent *hp;
  
    strcpy( hostname, "" );
    addr=inet_addr(ipaddr);
    hp=gethostbyaddr( (char *) &addr, sizeof(addr), AF_INET );
    if ( hp==NULL ) strcpy( hostname, ipaddr );
    else strcpy( hostname, hp->h_name );
}

int split(char ipaddr[], char ipmask[], char buf[])
{
    strcpy( ipaddr, "" );
    strcpy( ipmask, "" );
    strncpy( ipaddr, buf, strcspn( buf, "/" ));
    ipaddr[ strcspn( buf, "/" )]=0;
    trim(ipaddr);
    if ( !valid_ip( ipaddr )) { dump_error( 29, buf ); return -1; }
    if ( !strstr( buf, "/" )) strcpy( ipmask, "255.255.255.255" );
    else strcpy( ipmask, &(buf[strcspn( buf, "/" )+1]));
    
    trim(ipmask);
    
    if ( !valid_ip(ipmask)) {
	if ( strlen(ipmask)==0) strcpy( ipmask, "255.255.255.255" );
        else if ( atoi(ipmask)>=0 && atoi(ipmask)<=32 ) bitodot( ipmask, atoi(ipmask));
	else return -1;
    }
    
    return 1;
}

unsigned int compute_quantum ( unsigned int rate ) {
    unsigned int quantum=rate/8/1500;
    if (!quantum) quantum=1;
    return quantum;
}

int valid_dev(char dev[])
{
  int i;
  bool dot = false;

    if ( dev[0]==101 && dev[1]==116 && dev[2]==104 ) i=3; // eth
    else if ( dev[0]==112 && dev[1]==112 && dev[2]==112 ) i=3; // ppp
    else if ( dev[0]==105 && dev[1]==109 && dev[2]==113 ) i=3; // imq
    else if ( dev[0]==97 && dev[1]==116 && dev[2]==104 ) i=3;	// ath
    else if ( dev[0]==98 && dev[1]==114 ) i=2;			// br
    else if ( dev[0]==119 && dev[1]==108 && dev[2]==97 && dev[3]==110 ) i=4; // wlan
    else if ( dev[0]==98 && dev[1]==111 && dev[2]==110 && dev[3]==100 ) i=4; // bond
    else return -1;

    if ( dev[i]<48 || dev[i]>57 ) return -1;

    i++; 
  
    while ( dev[i]!=0 && dev[i]!=9 && dev[i]!=10 && dev[i]!=32 ) {
	if ( dev[i] == 46 ) {
	    if ( dot == true ) return -1;
    	    else dot = true;
	}
	else if (( dev[i]<48 || dev[i]>57 )) {
	    return -1; 
        }  
        i++;
	if ( i==MAX_IFACE ) return -1;
    }
    
    return true;
}

bool valid_ip(char ipaddr[])
{
    struct in_addr inaddr;
    if ( !inet_aton( ipaddr, &inaddr )) return false;
    if ( strcmp( ipaddr, inet_ntoa( inaddr ))) return false;
    return true;
}

bool valid_port(int tcpport)
{
    if (tcpport >= 1 && tcpport <= 65536) return true;
    else return false;
}

bool valid_whiteline(char buf[])
{
    if (!strlen(buf)) return true;
    else return false;
}

bool solid_ipmask(char ipmask[])
{
    unsigned long addr;

    if ( !valid_ip( ipmask )) return false;
    addr = htonl( inet_addr( ipmask ));
    for ( int n=1; n<32; n++ )
	if ((( addr>>n)&1)==0 && (( addr>>n-1)&1)==1 ) return false;
	
    return true;
}

int trim(char buf[])
{
    int dl;

    dl=strlen(buf);
    for ( int n=0; n<dl; n++ ) {
	if ( buf[n]==9 ) buf[n]=32;
	else if ( buf[n]==35) buf[n]=0;
	else if ( buf[n]==10) buf[n]=0;
    }
    while ( buf[0]==32 ) {
	dl=strlen(buf);
	for ( int m=0; m<(dl-1); m++ ) buf[m]=buf[m+1];
	buf[dl-1]=0;
    }
    dl=strlen(buf)-1;
    for ( int n=dl; n>=0; n-- ) {
	if (buf[n]==32) buf[n]=0;
	else break;
    }
    dl=strlen(buf);
    for ( int n=0; n<dl; n++ ) {
	if ( buf[n]==32 ) {
	    while ( buf[n+1]==32 ) {
		for ( int m=n; m<dl; m++ ) buf[m] = buf[m + 1];
	    }
	}
	if ((buf[n] >= 97) || (buf[n] <= 122)) continue;
	else if ((buf[n] >= 65) || (buf[n] <= 90)) continue;
	else if ((buf[n] >= 48) || (buf[n] <= 57)) continue;
	else if ((buf[n] == 43) || (buf[n] == 45)) continue;
	else if ((buf[n] == 60) || (buf[n] == 62) || (buf[n] == 46) || (buf[n] == 47)) continue;
	else {
	    printf( "\tforbidden char (%c):%s\n", buf[n], buf );
	    return -1;
	}
    }
    
    return 0;
}


int convert_simple_usersfile ( vector < char * > &fpv, FILE * fp, char dev_inet[MAX_IFACE], char section_download[SHORT_BUF], char section_upload[SHORT_BUF], char sections [LONG_BUF], bool resolve_hostname, bool make_comments )
{
    char *buf, usersbuf[LONG_BUF], hostname[LONG_BUF], ip[SHORT_IP_ADDR], dev[MAX_IFACE];

    while ( fgets( usersbuf, LONG_BUF, fp )) 
    {
	if ( !valid_ip( awk( usersbuf , 1 ))) continue;
	if ( !valid_dev( awk( usersbuf , 2 ))) continue;
        
	strcpy( ip, awk( usersbuf , 1 ));
	strcpy( dev, awk( usersbuf , 2 ));

	if ( !valid_ip(ip)) { dump_error( 29, usersbuf ); return -1; }   
	if ( !valid_dev(dev)) { dump_error( 16, usersbuf ); return -1; }   

        if ( resolve_hostname ) iptohostname( hostname , ip);
        else strcpy( hostname, ip );

        if ( make_comments )
        {
	    buf=new char[LONG_BUF];
            sprintf( buf, "\n############### %s ###", hostname );
    	    fpv.push_back(buf);
	}
	
	buf=new char[LONG_BUF];
        sprintf( buf , "class %s %s %s", section_download, dev , hostname );
	fpv.push_back(buf);
	buf=new char[LONG_BUF];
        sprintf( buf , "\tmatch dstip %s", ip);
	fpv.push_back(buf);
        if ( strstr ( usersbuf , " dl_low " )) {
	    buf=new char[LONG_BUF];
	    strcpy( buf , "\tlow " );
    	    strcat( buf , awk ( strstr( usersbuf , " dl_low " ) , 2 ));
	    fpv.push_back(buf);
        }
        if ( strstr ( usersbuf , " dl_ceil " )) {
	    buf=new char[LONG_BUF];
    	    strcpy( buf , "\tceil " );
    	    strcat( buf , awk ( strstr( usersbuf , " dl_ceil " ) , 2 ));
    	    fpv.push_back(buf);
        }
        if ( strstr ( usersbuf , " dl_rate " )) {
	    buf=new char[LONG_BUF];
    	    strcpy( buf , "\trate " );
    	    strcat( buf , awk ( strstr( usersbuf , " dl_rate " ) , 2 ));
	    fpv.push_back(buf);
        }
	
	buf=new char[LONG_BUF];
        sprintf( buf , "class %s %s %s", section_upload, dev_inet , hostname );
	fpv.push_back(buf);
	buf=new char[LONG_BUF];
        sprintf( buf , "\tmatch srcip %s", ip);
	fpv.push_back(buf);
        if ( strstr ( usersbuf , " ul_low " )) {
	    buf=new char[LONG_BUF];
    	    strcpy( buf , "\tlow " );
    	    strcat( buf , awk ( strstr( usersbuf , " ul_low " ) , 2 ));
	    fpv.push_back(buf);
        }
        if ( strstr ( usersbuf , " ul_ceil " )) {
	    buf=new char[LONG_BUF];
    	    strcpy( buf , "\tceil " );
    	    strcat( buf , awk ( strstr( usersbuf , " ul_ceil " ) , 2 ));
	    fpv.push_back(buf);
        }
        if ( strstr ( usersbuf , " ul_rate " )) {
	    buf=new char[LONG_BUF];
    	    strcpy( buf , "\trate " );
	    strcat( buf , awk ( strstr( usersbuf , " ul_rate " ) , 2 ));
	    fpv.push_back(buf);
        }
    }

    return 0;
}

int convert_extended_usersfile( vector < char * > &fpv, FILE * fp, char sections [LONG_BUF], bool resolve_hostname, bool make_comments )
{
    int n;
    char option[SHORT_BUF], value[SHORT_BUF], userline[LONG_BUF], hostname[LONG_BUF], sections_modes[LONG_BUF]="";
    char ip[MAX_IFACE], dev[MAX_IFACE], section_start[SHORT_BUF]="", section_end[SHORT_BUF]="";
    char *buf;
    vector < char * >::iterator fpvi;    

    fpvi=fpv_conffile.begin();                
    while ( ++fpvi != fpv_conffile.end())  
    { 
        strcpy( option, awk( *fpvi, 1 ));      
	trim( option );
	if ( !strlen(option)) continue;	
	if ( strstr( option, "<" ) && strstr( option, ">" ) && !strstr( option, "/" ))
	{
    	    strcpy( section_start, option );
	    strcpy( section, &(strstr(option, "<"))[1]);
	    section[strcspn( option, ">" )-1] = 0;
	    trim( section );
	    if ( !strcmp( section, "global" )) continue;
	    sprintf( section_start, "<%s>", section );
	    sprintf( section_end, "</%s>", section );
	    strcat( sections_modes, section );
	    bool mode_ok = false;
	    while ( ++fpvi != fpv_conffile.end()) 
    	    {
		strcpy( option, awk( *fpvi, 1 ));
    	        strcpy( value, awk( *fpvi, 2 ));
		trim( option );
	        trim( value );
		if ( !strcmp( option, section_end )) 
		{
		    if ( mode_ok ) 
			break;
		    else {
			printf( "\tNo mode defined for %s sections\n", section );
			return -1;			
		    }
		} 
		else if ( strstr(option, "<" ) && strstr( option, ">" )) 
		{
		    printf ( "\tsection %s is not properly closed\ncheck your config file\n", section );
		    return -1;
		}
		
		
		if ( !strlen(option) || !strlen(value)) continue;

		if ( !strcmp( option, "mode" )) 
	        {
	    	    if ( !strcmp( value, "download" )) 
		    {
	    		strcat( sections_modes, " dstip " );
	    		mode_ok = true;
		    } 
		    else if ( !strcmp( value, "upload" )) 
		    {
		        strcat( sections_modes, " srcip " );
			mode_ok = true;
		    } 
		    else 
		    {
		        printf( "\tbad mode in: %s \ncheck your config file\n", buf );
			return -1;
		    }
	        } 
	    }
	}
    }
    
    n = 0;
    while ( fgets( userline, LONG_BUF, fp )) {
	trim(userline);
	if ( valid_whiteline( userline )) continue;
	strcpy( ip, awk( userline, 1 ));
	if ( valid_ip( ip )) {
	    if ( resolve_hostname ) iptohostname( hostname, ip );
	    else strcpy(hostname, ip);
	    if ( make_comments )
	    {
		buf=new char[LONG_BUF];
	        sprintf( buf, "\n############### %s ###", hostname );
		fpv.push_back(buf);
	    }
	    for ( int i=2; strlen( awk( userline, i )); i++ ) {
		strcpy( option, awk( userline, i ));
		if ( !strcmp( option, "section" )) {
		    strcpy( section, awk( userline, i+1 ));
		    strcpy( dev, awk( userline, i+2 ));
		    buf=new char[LONG_BUF];	    	    
		    sprintf( buf, "class %s %s %s", section, dev, hostname );
		    fpv.push_back(buf);
		    if ( !strstr( sections_modes, section )) {
			printf("\nthere isn't configure %s section\n", section );
			return -1;
		    }
	    	    buf=new char[LONG_BUF];	    	    		    
		    sprintf(buf, "    match %s %s", awk( strstr( sections_modes, section ), 2 ), ip );
		    fpv.push_back(buf);
		} 
		else if ( !strcmp( option, "low" )) {
	    	    buf=new char[LONG_BUF];	    	    		    		
		    sprintf(buf, "    low %s", awk(userline, i + 1));
		    fpv.push_back(buf);		    
		} 
		else if ( !strcmp( option, "ceil" )) {
	    	    buf=new char[LONG_BUF];	    	    		    		
		    sprintf(buf, "    ceil %s", awk(userline, i + 1));
		    fpv.push_back(buf);		    
		} 
		else if ( !strcmp( option, "rate" )) {
	    	    buf=new char[LONG_BUF];	    	    		    		
		    sprintf(buf, "    rate %s", awk(userline, i + 1));
		    fpv.push_back(buf);		    
		}
	    }
	} 
	else {
	    printf( "\t%s is not valid ip addr\n", ip );
	    return -1;
	}
    }

    return 0;
}

int fpv_section_i ( vector < char * >::iterator &fpvi_begin, vector < char * >::iterator &fpvi_end, vector < char * > &fpv, char section[] )
{
  char section_begin[LONG_BUF]="";
  char section_end[LONG_BUF]="";

  vector < char * >::iterator fpvi;
  
  sprintf(section_begin, "<%s>", section);
  sprintf(section_end, "</%s>", section);

  fpvi = fpv.begin();  

  while ( fpvi != fpv.end() ) {
	if ( !strcmp ( *fpvi , section_begin )) fpvi_begin = fpvi;
	else if ( !strcmp ( *fpvi , section_end )) fpvi_end = fpvi;
	fpvi ++;
  }
  return 1;
}

int file_is_readable ( char path[MAX_PATH] ) 
{
    if ( access( path, R_OK ) == -1 ) {
	return -1;	
    }

    return 0;
}

int conv_to_fpv ( vector < char * > &fpv, FILE * fp , filetype type , bool add_to_protected_marks, char sections [])
{

// wrzucic jakies tlumaczenie przestarzalych opcji razem z warningowaniem
    int cbuf;
    int buf_counter = 0;    
    bool state_store = true;
    char * buf = new char [LONG_BUF];
    char sec[SHORT_BUF]="";
    bool running_class=false;
    int n;
    bool file_defined=false;
    FILE *incfp;
    
    vector < char * > fpv_tmp;
    vector < char * > fpv_tmp2;

    while ((cbuf = fgetc(fp)) != -1 ) 
    {
        if ( cbuf == 35 ) state_store = false;	// '#'
	if ( cbuf == 59 ) cbuf = 10;		// ';'
	if ( cbuf == 10 ) state_store = true;	// 'NL'
	if ( state_store ) 
	{
	    buf[buf_counter]=cbuf;
	    buf_counter++;
	    if ( buf_counter == LONG_BUF-1 ) { dump_error( 25, buf ); return -1; }
	}
	if ( cbuf == 10 )
	{
	    buf[buf_counter]=0;
	    buf_counter=0;
	    state_store = true;	    	    
	    
	    if ( trim(buf)==-1 ) { return -1; }
	    
	    if ( valid_whiteline(buf)) continue;

	    if ( !strcmp( awk( buf, 1 ), "include" )) {
	        if ( fpv_tmp.size()) {
		    for ( unsigned int i = 0; i < fpv_tmp.size(); i++ ) {
    		        if (running_class) fpv.push_back ( fpv_tmp[i] );
		    }
        	    fpv_tmp.clear();
		}
    		
		if ( fill_include_file_attrib( buf, file_defined ) == -1 ) return -1;		
	    
	        if ( !file_defined ) continue;
	    
	        if ( file_is_readable( include_file_attrib.path ) == -1 ) { dump_error( 26, buf ); return -1; }
	    
	        incfp = fopen( include_file_attrib.path, "r" );
	        fseek ( incfp, 0, SEEK_SET );
	    
		if ( !strcmp( include_file_attrib.type, "file" )) {
		    if ( conv_to_fpv( fpv, incfp , type , add_to_protected_marks , sections ) == -1 ) { fclose (incfp); return -1; }
	        }
    		else if ( !strcmp( include_file_attrib.type, "simple-usersfile" )) {
		    if ( convert_simple_usersfile ( fpv, incfp , include_file_attrib.iface_inet, include_file_attrib.section_download, include_file_attrib.section_upload, sections, include_file_attrib.resolve_hostname, false ) == -1 ) { fclose (incfp); return -1; }
		}
		else if ( !strcmp( include_file_attrib.type, "extended-usersfile" )) {
		    if ( convert_extended_usersfile ( fpv, incfp, sections, include_file_attrib.resolve_hostname, false ) == -1 ) { fclose (incfp); return -1; }
		}
		else {
		    dump_error( 24, buf );
		    return -1;
	        }
	        fclose (incfp); 	
		file_defined=false;
		continue;
	    }    
	    if ( type==classtype ) {
		if ( !strcmp( awk( buf, 1 ), "class" )) {
		    if ( fpv_tmp.size()) {
    			for ( unsigned int i = 0; i < fpv_tmp.size(); i++ ) {
			    if (running_class) fpv.push_back(fpv_tmp[i]);
			}
			fpv_tmp.clear();
		    }
		    n=1;                                                                                                                               
        	    running_class=false;                                                                                                                       
		    strcpy ( sec, awk( buf, 2 ));
	    	    while ( strlen( awk( sections, n ) )) {
        	        if ( !strcmp ( awk( sections, n ), sec )) {
                    	    running_class = true; break;
        	        }
            	    	n++;
    		    }
		}
	        if (( !strcmp( awk( buf, 1 ), "match" )) || ( !strcmp( awk2( buf, 1 ), "class" ))) { 
		    if ( running_class ) fpv.push_back (buf);
		}
  		else {
		    if ( running_class ) {
			if ( directive_split ( fpv_tmp, buf ) == -1 ) return -1;
		    }
		}
	    }
	    else { 
		if ( directive_split ( fpv, buf ) == -1 ) return -1;
	    }	

    	    if ( !add_to_protected_marks ) continue;
	    
            if (( type==conftype ) && ( !strcmp( awk( buf, 1 ), "iface" ))) {
                if ( strstr (buf, " mark " ) ) protected_marks.push_back( atoi( awk( strstr ( buf, " mark "), 2 )));
            }
            else if (( type==classtype ) && ( !strcmp( awk( buf, 1 ), "match" ))) {
    	        if ( strstr( buf, " mark " )) protected_marks.push_back( atoi( awk( strstr ( buf, " mark " ), 2 )));	
                if ( strstr( buf, " set-mark " )) protected_marks.push_back( atoi( awk( strstr (buf, " set-mark "), 2 )));			
            }
            else if (( type==classtype ) && ( !strcmp( awk( buf, 1 ), "set-mark" ))) protected_marks.push_back( atoi( awk( buf, 2 )));	

	    buf = new char [LONG_BUF];			    
	}
    }
    
    if ( ( type==classtype ) && ( fpv_tmp.size()))
    {
        for ( unsigned int i = 0; i < fpv_tmp.size(); i++ ) 
	{
	    if (running_class) fpv.push_back ( fpv_tmp[i] ); 
	}    
        fpv_tmp.clear();			    
    }
    return 0;
}

bool wordinstr ( char buf[], char arg[] ) 
{
    unsigned int n = 0;
    
    while ( strlen(awk( buf, ++n ))) {
	if ( !strcmp( awk( buf, n ), arg )) return true; 
    }
    return false;
}

int directive_split ( vector < char * > &fpv, char arg [] )
{
    char * buf;
    char option[SHORT_BUF], directive[SHORT_BUF], param[SHORT_BUF], value[SHORT_BUF], opt_default[SHORT_BUF]="";
    bool inside_l1_valuelist=false;	    
    bool inside_l1_paramlist=false;
    
    // pobiera 1 slowo, nastepnie sprawdza czy pojawila sie nowa dyrektywa jesli nie to ...... hmmm zglaszac blad?
    static char l1_value[LONG_BUF]="low ceil rate hold htb-prio htb-scheduler reload";
    // pobiera 1 slowo, nastepnie sprawdza czy pojawila sie nowa dyrektywa jesli nie to przyjmuje ze ma do czynienia z kolejna wartoscia
    static char l1_valuelist[LONG_BUF]="debug";
    // pobiera 2 slowa, nastepnie sprawdza czy pojawila sie nowa dyrektywa jesli nie przyjmuje ze ma do czynienia z kolejnym parametrem
    static char l1_paramlist[LONG_BUF]="section htb sfq esfq include iptables";        
    // nie pobiera kolejnych slow, nastepnie sprawdza czy pojawila sie nowa dyrektywa jesli nie to ...... hmmm zglaszac blad?
    static char l1_word[LONG_BUF]="iptables-return imq-redirect do-not-shape virtual wrapper";

    unsigned int n = 0;
    
    if ( !strcmp( awk( arg, 1 ), "default" )) {
	strcpy( opt_default, "default" );
	n++;
    }	

    while ( strlen( awk( arg, ++n ))) {
    	strncpy( option, awk( arg, n ), SHORT_BUF );
	if ( wordinstr( l1_value, option )) {
	    strcpy( directive, option );
	    strncpy( value, awk( arg, ++n ), SHORT_BUF );
	    buf = new char [LONG_BUF];
	    sprintf(buf, "%s %s %s", opt_default, directive, value );
	    fpv.push_back (buf);
	    inside_l1_valuelist=false;	    
	    inside_l1_paramlist=false;
	}
	else if ( wordinstr( l1_word, option )) {
	    buf = new char [LONG_BUF];
	    sprintf(buf, "%s %s", opt_default, option );
	    fpv.push_back (buf);    
	    inside_l1_valuelist=false;	    
	    inside_l1_paramlist=false;
	}
	else if ( wordinstr( l1_valuelist, option )) {
	    strcpy( directive, option );
	    strncpy( value, awk( arg, ++n ), SHORT_BUF );
	    buf = new char [LONG_BUF];
	    sprintf(buf, "%s %s %s", opt_default, directive, value );
	    fpv.push_back (buf);
	    inside_l1_valuelist=true;	    
	    inside_l1_paramlist=false;
	}
	else if ( wordinstr( l1_paramlist, option )) {
	    strcpy( directive, option );
	    strncpy( param, awk( arg, ++n ), SHORT_BUF );
	    strncpy( value, awk( arg, ++n ), SHORT_BUF );
	    buf = new char [LONG_BUF];
	    sprintf( buf, "%s %s %s %s", opt_default, directive, param, value );
	    fpv.push_back ( buf );    
	    inside_l1_valuelist=false;	    
	    inside_l1_paramlist=true;
	}
	else if ( inside_l1_valuelist ) {
	    buf = new char [LONG_BUF];
	    sprintf(buf, "%s %s %s", opt_default, directive, option );
	    fpv.push_back( buf );
	}
	else if ( inside_l1_paramlist ) {
	    strncpy( value, awk( arg, ++n ), SHORT_BUF );
	    buf = new char [LONG_BUF];
	    sprintf(buf, "%s %s %s %s", opt_default, directive, option, value );
	    fpv.push_back (buf);    
	}
	else if ( n == 1 ) {
	    fpv.push_back (arg);
	    return 1;
	}
	else { 
	    dump_error( 24, arg );
	    return -1;
	}
    }
    
    return 0;
    
}

int fill_include_file_attrib ( char arg [], bool &file_defined )
{
    char param[SHORT_BUF], value[LONG_BUF];
    unsigned int n=1;
    
    while ( strlen( awk( arg, ++n ))) {
        strcpy( param, awk( arg, n ));
        strcpy( value, awk( arg, ++n ));
	
	if ( !strlen(param)) { dump_error( 24, arg ); return -1; }
	if ( !strlen(value)) { dump_error( 24, arg ); return -1; }
	
	if ( !strcmp( param, "file" )) {
	    strcpy( include_file_attrib.path, value );
	    strcpy( include_file_attrib.type, "file" );
	    file_defined=true;
	}
	else if ( !strcmp( param, "extended-usersfile" )) {
	    strcpy( include_file_attrib.path, value );	
	    strcpy( include_file_attrib.type, "extended-usersfile" );	    
	    file_defined=true;
	}
	else if ( !strcmp( param, "simple-usersfile" )) {
	    strcpy( include_file_attrib.path, value );
	    strcpy( include_file_attrib.type, "simple-usersfile" );	    
	    file_defined=true;
	}
	else if ( !strcmp( param, "download-section" )) {
	    strncpy( include_file_attrib.section_download, value, strlen(value));	
	}
	else if ( !strcmp( param, "upload-section" )) {
	    strncpy( include_file_attrib.section_upload, value, strlen(value));		
	}
	else if ( !strcmp( param, "iface-inet" )) {
	    strncpy( include_file_attrib.iface_inet, value, strlen(value));		
	}
	else if ( !strcmp( param, "resolve-hostname" )) {
	    if ( !strcmp( value, "true" )) include_file_attrib.resolve_hostname=true;
	    else if ( !strcmp( value, "false" )) include_file_attrib.resolve_hostname=false;
	    else { dump_error( 24, arg ); return -1; }
	}
	else { 
	    dump_error( 24, arg );
	    return -1;
	}
    }
    
    return 1;
}


void system_ipt(char command[])
{
  if (debug_ipt) {
    printf("%s:%s\n", section, command);
  }
  system(command);
}

void system_tc(char command[])
{
  if (debug_tc) {
    printf("%s:%s\n", section, command);
  }
  system(command);
}

long int power( int val , int inc )
{
  long int result = 1;
  for ( int n = 1; n <= inc ; n++ ) result = result * val;
  return result;
}
	    
void help()
{
    printf( "\n\tNiceshaper version:%s\n", version);
    printf( "\thttp://niceshaper.jedwabny.net\n\n");
    printf( "\tusage: niceshaper {start|stop|restart|convert|stats}\n\n");
    
    printf( "\tto overwrite default config files locations:\n");
    printf( "\t--conffile PATH-TO-FILE\n");
    printf( "\t--classfile PATH-TO-FILE\n\n");
    printf( "\tto overwrite config dir:\n");
    printf( "\t--confdir PATH-TO-DIR\n\n");
    
    printf( "\tconvert usersfile:\n");
    printf( "\t--extended-usersfile PATH-TO-FILE - extended usersfile is file format from NiceShaper 0.6\n");
    printf( "\t--simple-usersfile PATH-TO-FILE - simple usersfile is file format from NiceShaper 0.5\n");        
    printf( "\t--outfile PATH-TO-FILE - if not defined classes will be dumped on your terminal\n");    
    printf( "\t--resolve-hostname {true|false}\n\n");     
       
    printf( "\trequired for convert simple-usersfile:\n");
    printf( "\t--download-section SECTION - for download configured section\n");
    printf( "\t--upload-section SECTION - for upload configured section\n");
    printf( "\t--iface-inet IFACE - internet interface\n\n");    
    
    printf( "\tother:\n");
    printf( "\t--no-daemon to no act as background proces\n");
    printf( "\t--force-pidfile force run even if there is pidfile\n\n");	
}

