#include "net.h"

netattrib::netattrib()
{
  ipt_applied = false;
}

netattrib::~netattrib()
{
  char buf[LONG_BUF];

  if (!alias) {
    sprintf(buf, "tc qdisc del root dev %s 2> /dev/null > /dev/null", dev);
    system_tc(buf);
  }
  if (ipt_applied) {
    sprintf(buf, "iptables -t mangle -D %s %s -j %s", ipt_myparent, ipt_match, ipt_mychain);
    system_ipt(buf);
  }
}
int netattrib::init(char buf[], bool alias_)
{
    char mode[16];

    alias = alias_;
  
    strcpy ( match , "" );
    strcpy(dev, awk(buf, 2));
    strcpy(mode, awk(buf, 3));
    if ( !strcmp(mode, "match" ) )  {
	strcpy(match, strstr(buf, "match"));
    }
    else if ( !strcmp(mode, "src" ) )  {
	strcpy(match, "srcip ");
	strcat(match, awk( buf, 5));
    }
    else if ( !strcmp(mode, "dst" ) )  {
	strcpy(match, "dstip ");
	strcat(match, awk( buf, 5));
    }
    else {
	return -1;
    }
    if ( gen_ipt_filter(ipt_match, match) == -1 ) 
    {
	dump_error( 18, match );
	return -1;
    }  
    return 0;
}

int netattrib::envinit()
{
  char buf[LONG_BUF];
 
  sprintf(buf, "iptables -t mangle %s %s %s -j %s", ipt_myparent_mode, ipt_myparent, ipt_match, ipt_mychain);
  system_ipt(buf);
  ipt_applied = true;
  if (strstr(dev, "imq")) { sprintf(buf, "ip link set %s up", dev); system_tc(buf); }
  if (!alias) {
    sprintf(buf, "tc class add dev %s parent 1:1 classid 1:%d htb rate %d quantum %d", dev, section_id, section_htb_ceil, compute_quantum(section_htb_ceil));
    system_tc(buf);
  }
  return 0;
}
