#ifndef NICESHAPER_H
#define NICESHAPER_H

#define version "0.6rc4"

#include <unistd.h>		
#include <stdlib.h>		
#include <signal.h>		
#include <sys/wait.h>
#include <fcntl.h>		
#include <netdb.h>		
#include <arpa/inet.h>		
#include <sys/time.h>		
#include <sys/types.h>		
#include <iostream>
#include <vector>
#include <string>

using namespace std;

const int LONG_BUF = 1024;
const unsigned int SHORT_BUF = 64;
const int LONG_IP_ADDR = 32;
const int SHORT_IP_ADDR = 16;
const int MAX_IFACE = 12;
const int MAX_PATH = 256;

enum unittype { bps = 8, kbps = 8192, mbps = 8388608, bit = 1, kbit = 1024, mbit = 1048576 };
enum filtertype { u32 = 1, fw = 2 };
enum classtype { standard = 1, donotshape = 2, virtualclass = 3, wrapper = 4 };
enum qdisctype { none = 1, sfq = 2, esfq = 3 };
enum langtype { en = 1 , pl = 2 };
enum filetype { conftype = 1 , classtype = 2 };

void run(int, char *[]);
void signalterm(int);
void show_stats();
void iptohostname(char[], char[]);
void sys(char[]);
int dotobit(char[]);
bool bitodot(char[], int);
bool getip(char[], char[]);
int split(char[], char[], char[]);
int valid_dev(char[]);
bool valid_ip(char[]);
bool solid_ipmask(char[]);
bool valid_port(int);
bool valid_whiteline(char[]);
int trim(char[]);
char *awk(char[], unsigned int);
char *awk2(char[], unsigned int);
long int unitconvert(char[], unittype);
long int unitconvert(long int, unittype);
int gen_ipt_filter(char[], char[]);
void convert_usersfile();
void convert_old_usersfile();
int convert_simple_usersfile ( vector < char * > &, FILE *, char [], char [], char [], char [], bool, bool );
int convert_extended_usersfile ( vector < char * > &, FILE *, char [], bool, bool );
int fill_include_file_attrib ( char [], bool & );
void help();
void system_ipt(char[]);
void system_tc(char[]);
enum unittype getunit(char[]);
unsigned int compute_quantum (unsigned int);
long int power( int , int );
int file_is_readable ( char [] );
int conv_to_fpv ( vector < char * > &, FILE *, filetype, bool, char [] ) ;
bool wordinstr ( char [], char [] );
int directive_split ( vector < char * > &, char [] );
int fpv_section_i ( vector < char * >::iterator &, vector < char * >::iterator &, vector < char * > &, char [] );

extern char section[SHORT_BUF];
extern char ipt_mychain[SHORT_BUF];
extern char ipt_myparent[SHORT_BUF];
extern char ipt_myparent_mode[SHORT_BUF];

extern unsigned int working;
extern unsigned int section_htb_ceil;
extern unsigned int section_shape;
extern unsigned int section_interactive_sum;
extern unsigned int section_id;
extern unsigned int section_max_permills;
extern unsigned int section_classes;
extern langtype lang;
extern unittype statsunit;
extern char chstatsunit[8];
extern char markifaces[LONG_BUF];
extern bool overload;
extern bool debug_ipt;
extern bool debug_tc;
extern bool i_am_parent;
extern bool fatal_error;

extern vector < unsigned int > protected_marks;

#endif
